/**********************************************************************
 * CD Jukebox by Nathan Strong (gblues@jps.net)
 *
 * This software is covered by the GNU Public License. See COPYING
 * file for details on the license. All code contained in these files
 * is (c) 1999 Nathan Strong.
 **********************************************************************/

#include "main.h"

struct config_data config;

void create_config(void)
{
  printf("Detecting CD-ROM drives. Ignore any \"CDROM not ready\" errors.\n");
  if( !detect_drives() )
  {
    printf("No drives detected!\n");
    exit_cdplayer();
  }
  write_config();
}

void write_config(void)
{
  DRIVE_DATA *dr;
  int count = 0;
  char fname[256];

  chdir("/dev");
  printf("Making symlinks and setting permissions: "); fflush(NULL);
  for( dr = config.drives; dr != NULL; dr = dr->next )
  {
    sprintf(fname, "cdrom%d", count++);
    unlink(fname);
    symlink(dr->filename, fname);
    chmod(dr->filename, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IROTH);
    printf("."); fflush(NULL);
  }
  printf("done.\n");
  exit_cdplayer();
}

void load_drives(void)
{
  int i = 0;
  int fd;
  char fname[256];

  sprintf(fname, "/dev/cdrom%d", i);
  if( (fd = open(fname, O_RDONLY)) < 0 )
  {
    fprintf(stderr, "Error opening %s. Did you run me as root yet?\n",
            fname);
    exit_cdplayer();
  }
  close(fd);

  for( i = 0; ; i++ )
  {
    DRIVE_DATA *dr, *list;
    sprintf(fname, "/dev/cdrom%d", i);
    if( (fd = open(fname, O_RDONLY)) < 0 )
      break;
    close(fd);
    dr           = malloc(sizeof *dr);
    dr->filename = strdup(fname);
    dr->next     = NULL;
    if( config.drives == NULL ) config.drives = dr;
    else
    {
      for( list = config.drives; list->next != NULL; list = list->next );
      list->next = dr;
    }
  }
}
